unit clock3_;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, jpeg, StdCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Image1: TImage;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);

    //    
    procedure Vector(x0,y0,a,l: integer);
    procedure DrawClock;
    procedure Button1Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  Form1: TForm1;

implementation
{$R *.dfm}

uses
   DateUtils; //    SecondOf,
              // MinuteOf  HourOf

const
  R = 75 ;    //   

var
 x0,y0: integer;         //  
 ahr,amin,asec: integer; //   ()

//  
procedure TForm1.FormCreate(Sender: TObject);
var
    t: TDateTime;
begin
  //   
  //     
  ClientHeight := (R+30)*2;
  ClientWidth  := (R+30)*2;
  x0 := R+30;
  y0 := R+30;

  t := Now();

  //  
  ahr :=  90 - HourOf(t)*30-(MinuteOf(Today)div 12)*6;
  amin := 90 - MinuteOf(t)*6;
  asec := 90 - SecondOf(Today)*6;

  Timer1.Interval := 1000; //     1 
  //Timer1.Enabled := True;  //  
end;

//       (x0,y0)
procedure TForm1.Vector(x0,y0: integer; a, l: integer);
    // x0,y0 -  
    // a -    x  
    // l -  
const
  GRAD = 0.0174532;   //       
var
  x,y: integer;       //   
begin
  Canvas.MoveTo(x0,y0);
  x := Round(x0 + l*cos(a*GRAD));
  y := Round(y0 - l*sin(a*GRAD));
  Canvas.LineTo(x,y);
end;

//  
procedure TForm1.DrawClock;
var
    t: TDateTime;
begin
  //      6 ,
  //  - 30.

{  //   
  Canvas.Pen.Color := clBtnFace;
  Canvas.Pen.Width :=3;
  // 
  Vector(x0,y0, ahr, R-20);
  // 
  Vector(x0,y0, amin, R-15);
  // 
  Vector(x0,y0, asec, R-7);
}
  t := Now();

  Image1.Refresh;
  //   
  ahr :=  90 - HourOf(t)*30-(MinuteOf(t)div 12)*6;
  amin := 90 - MinuteOf(t)*6;
  asec := 90 - SecondOf(t)*6;
{
  //  
  //  
  Canvas.Pen.Width := 3;
  Canvas.Pen.Color := clBlack;
  Vector(x0,y0, ahr, R-20);
}
  //  
  Canvas.Pen.Width := 2;
  Canvas.Pen.Color := clBlack;
  Vector(x0,y0, amin, R-15);

  //ShowMessage('');

  //  
  Canvas.Pen.Width := 1;
  Canvas.Pen.Color := clYellow;
  Vector(x0,y0, asec, R-7);
end;

//   ( )
procedure TForm1.FormPaint(Sender: TObject);
begin
  //DrawClock;
end;


//     
procedure TForm1.Timer1Timer(Sender: TObject);
begin
    DrawClock;
    Timer1.Enabled := False;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
    //Timer1.Enabled := True;
    DrawClock;
end;

end.
